#ifndef SHATTERBLOX_CLASSES_H
#define SHATTERBLOX_CLASSES_H

#include "Jester.h"
#include "Global.h"

class CPaddle
{
public:
	CPaddle();
	float x1;
	float x2;
	float y1;
	float y2;
};
class CBall
{
public:
	CBall();
	bool Active;
	float x1;
	float y1;
	float x2;
	float y2;
	float VelX;
	float VelY;
};

class CPowerup
{
public:
	int Type;
	bool Active;
	float VelY;
	float x1;
	float y1;
	float x2;
	float y2;
};

class CBlock
{
public:
	int MyCurAniFrame;
	DWORD MyNextAnimate;
	bool Active;
	int Type;
	float VelX;
	float VelY;
	int MyMaxLeftX;
	int MyMaxRightX;
	RECT Block;
};

class CLevel
{
public:
	~CLevel();
	void UnloadLevel();
	int NumOfBlocks;
	char* LevelName;
	char* CreatorName;
	CBlock* Blocks;
};

struct CMenus
{
public:
	CMenus();
	bool InCredits;
	bool InHighScore;
	bool InLoadGame;
	bool InLoadLevel;
};

class CGame
{
public:
	CGame();
	bool Abort;
	POINT MousePos;
	CLevel LoadedLevel;
	CMenus Menus;
	bool TestPlay;
	bool Over;
	bool Started;
	bool InMenus;
	int NumOfBlocksLeft;
	int NumOfBallsLeft;
	unsigned int Score;
	int Level;
	int Lives;
};

struct CFileHeader
{
	int NumOfBlocks;
	int CeatorLength;
	int LevelNameLength;
};

#endif


