#include "Jester.h"

// CTextureList implimentation
CTextureList::CTextureList()
{
	myHead = new CTextureHead;
}

CTextureList::~CTextureList()
{
	delete myHead;
}

void CTextureList::Insert(char *TexName)
{
	myHead->Insert(TexName);
}

bool CTextureList::TextureLoaded(char* TexName)
{
	return myHead->TextureLoaded(TexName);
}

IDirect3DTexture8* CTextureList::GetTexture(char* TexName)
{
	return myHead->GetTexture(TexName);
}

// CTextureHead implimentation
CTextureHead::CTextureHead()
{
	myNext = new CTextureTail;
}

CTextureHead::~CTextureHead()
{
	delete myNext;
}

void CTextureHead::Insert(char *TexName)
{
	myNext = new CTextureNode(myNext, TexName);
}

bool CTextureHead::TextureLoaded(char *TexName)
{
	return myNext->TextureLoaded(TexName);
}

IDirect3DTexture8* CTextureHead::GetTexture(char* TexName)
{
	return myNext->GetTexture(TexName);
}

// CTextureNode implimentation
CTextureNode::CTextureNode(CTextureNode *myNewNext, char* myNewTextureName)
{
	myNext = myNewNext;
	myTextureName = new char[strlen(myNewTextureName)+1];

	strcpy(myTextureName, myNewTextureName);
	
	if(FAILED(D3DXCreateTextureFromFileEx(Jester->pd3dDevice, myTextureName, 0, 0, 0, 
		           0, D3DFMT_UNKNOWN, D3DPOOL_DEFAULT, D3DX_DEFAULT, 
				     D3DX_DEFAULT, 0xffff00ff, 0, 0, &myTexture)))
	{
		MessageBox(Jester->MainWindow, "D3DXCreateTextureFromFileEx FAILED", "Error", 0);
		Jester->Log("D3DXCreateTextureFromFile FAILED");
		PostQuitMessage(1);
	}
}

CTextureNode::CTextureNode(){}

CTextureNode::~CTextureNode()
{
	delete myNext;
}

bool CTextureNode::TextureLoaded(char* TexName)	
{
	if(strcmp(TexName, myTextureName) == 0) return true;
	else return myNext->TextureLoaded(TexName);	
}

IDirect3DTexture8* CTextureNode::GetTexture(char* TexName)
{
	if(strcmp(TexName, myTextureName) == 0) return myTexture;
	else return myNext->GetTexture(TexName);
}

// CTextureTail implimentation
CTextureTail::~CTextureTail(){}
bool CTextureTail::TextureLoaded(char *TexName)
{
	return false;
}
IDirect3DTexture8* CTextureTail::GetTexture(char* TexName)
{
	return 0;
}
