#define WIN32_LEAN_AND_MEAN
#include "Global.h"
#include "resource.h"

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) 
{
	Jester = new CJester;
	Jester->LogInit();

	g_hInstance = hInstance;

	WNDCLASSEX WndClass;
    HWND hwnd;
    MSG msg;

    WndClass.cbSize        = sizeof(WNDCLASSEX);
    WndClass.style         = NULL;
    WndClass.lpfnWndProc   = WndProc;
    WndClass.cbClsExtra    = 0;
    WndClass.cbWndExtra    = 0;
    WndClass.hInstance     = hInstance;
    WndClass.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
    WndClass.hCursor       = LoadCursor(NULL, IDC_ARROW);
    WndClass.hbrBackground = 0;
    WndClass.lpszMenuName  = NULL;
    WndClass.lpszClassName = "WindowClass";
    WndClass.hIconSm       = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));

    if(!RegisterClassEx(&WndClass)) 
	{
		MessageBox(0, "Window Registration Failed!", "Error!", MB_ICONSTOP | MB_OK);
		Jester->Log("Window Registration Failed!");
        return 0;
    }

    hwnd = CreateWindowEx(NULL, 
		                  "WindowClass", 
						  "4e3", 
						  WS_POPUP | WS_VISIBLE, 
						  0, 0,
						  200, 200, 
						  NULL, NULL,
						  hInstance,
						  NULL);

    if(!hwnd)
	{
        MessageBox(0, "Window Creation Failed!", "Error!", MB_ICONSTOP | MB_OK);
		Jester->Log("Window Creation Failed!");
        return 0;
    }
	g_hwnd = hwnd;
		
	if(!Jester->InitD3D(hwnd, 800, 600, true)) return -1;
	//if(!Jester->SoundInit()) return -1;
	if(!GameInit()) return -1;
	ShowCursor(FALSE);

	//HSTREAM sound = Jester->CreateSound("electric.mp3", true);
	//Jester->PlaySound(sound, false);

	static DWORD oldtime = timeGetTime()+6000;	

	while(true)
	{
		Jester->BeginFrame();
		Jester->TextOutWhite(240, 300, "GameDev.net 4 Elements 3 Contest Entry");
		Jester->TextOutWhite(220, 5, "Copyright 2002 Elijah Sheppard aka elis-cool");
		Jester->EndFrame();
		if(timeGetTime() > oldtime)break;
	}
	oldtime = timeGetTime()+7000;

	while(true)
	{
		Jester->BeginFrame();
		Jester->TextOutWhite(300, 400, "       Please Note:");
		Jester->TextOutWhite(300, 380, "The following people rule:");
		Jester->TextOutWhite(300, 360, "      - Dave Astle");
		Jester->TextOutWhite(300, 345, "      - Kevin Hawkins");
		Jester->TextOutWhite(220, 5, "Copyright 2002 Elijah Sheppard aka elis-cool");
		Jester->EndFrame();
		if(timeGetTime() > oldtime)break;
	}
	
	while(TRUE) // Game Loop
	{
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			if(msg.message == WM_QUIT) break; // Exit Game Loop

			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		GameMain();
    }

	oldtime = timeGetTime()+5000;
	
	if(Game.Lose || Game.Win)
	{
		while(true)
		{
			Jester->BeginFrame();
			if(Game.Lose) Jester->TextOutWhite(300, 345, "You Lose!! MUHAHAHA!!!");
			if(Game.Win) Jester->TextOutWhite(300, 345, "You Win!!");
			Jester->TextOutWhite(220, 5, "Copyright 2002 Elijah Sheppard aka elis-cool");
			Jester->EndFrame();
			if(timeGetTime() > oldtime)break;
		}
	}

	Jester->Shutdown();
	ShowCursor(TRUE);

    return msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	switch(Message) 
	{
    case WM_DESTROY:
        PostQuitMessage(0);
		break;

	case WM_LBUTTONDOWN:
		{
			Player.Shooting = true;
		}
		break;

	case WM_LBUTTONUP:
		{
			Player.Shooting = false;
		}
		break;

    default:
        return DefWindowProc(hwnd, Message, wParam, lParam);
    }
    return 0;
} 

